/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: class_3
//!	Generated Date	: Thu, 9, Feb 2012  
	File Path	: DefaultComponent\DefaultConfig\class_3.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "class_3.h"
//#[ ignore
#define Default_class_3_class_3_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class class_3
class_3::class_3(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(class_3, class_3(), 0, Default_class_3_class_3_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initStatechart();
}

class_3::~class_3() {
    NOTIFY_DESTRUCTOR(~class_3, false);
}

bool class_3::startBehavior() {
    bool done = false;
    done = C::startBehavior();
    return done;
}

void class_3::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    state_2_subState = OMNonState;
    state_1_subState = OMNonState;
}

void class_3::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.state_0");
        rootState_subState = state_0;
        rootState_active = state_0;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus class_3::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case state_5:
        {
            if(IS_EVENT_TYPE_OF(F_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("4");
                    state_1_exit();
                    NOTIFY_STATE_ENTERED("ROOT.state_3");
                    rootState_subState = state_3;
                    rootState_active = state_3;
                    NOTIFY_TRANSITION_TERMINATED("4");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = state_1_handleEvent();
                }
            break;
        }
        case state_0:
        {
            if(IS_EVENT_TYPE_OF(E_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.state_0");
                    //#[ transition 1 
                    getItsD()->GEN(G);
                    //#]
                    state_1_entDef();
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            break;
        }
        case state_4:
        {
            if(IS_EVENT_TYPE_OF(F_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("3");
                    state_2_exit();
                    NOTIFY_STATE_ENTERED("ROOT.state_3");
                    rootState_subState = state_3;
                    rootState_active = state_3;
                    NOTIFY_TRANSITION_TERMINATED("3");
                    res = eventConsumed;
                }
            
            
            break;
        }
        
        default:
            break;
    }
    return res;
}

void class_3::state_2_exit() {
    if(state_2_subState == state_4)
        {
            NOTIFY_STATE_EXITED("ROOT.state_2.state_4");
        }
    state_2_subState = OMNonState;
    
    NOTIFY_STATE_EXITED("ROOT.state_2");
}

void class_3::state_2_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.state_2");
    rootState_subState = state_2;
    NOTIFY_STATE_ENTERED("ROOT.state_2.state_4");
    state_2_subState = state_4;
    rootState_active = state_4;
}

void class_3::state_1_exit() {
    if(state_1_subState == state_5)
        {
            NOTIFY_STATE_EXITED("ROOT.state_1.state_5");
        }
    state_1_subState = OMNonState;
    
    NOTIFY_STATE_EXITED("ROOT.state_1");
}

void class_3::state_1_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.state_1");
    rootState_subState = state_1;
    NOTIFY_STATE_ENTERED("ROOT.state_1.state_5");
    state_1_subState = state_5;
    rootState_active = state_5;
}

IOxfReactive::TakeEventStatus class_3::state_1_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(F_Default_id))
        {
            NOTIFY_TRANSITION_STARTED("2");
            state_1_exit();
            state_2_entDef();
            NOTIFY_TRANSITION_TERMINATED("2");
            res = eventConsumed;
        }
    
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedclass_3::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    OMAnimatedC::serializeAttributes(aomsAttributes);
}

void OMAnimatedclass_3::serializeRelations(AOMSRelations* aomsRelations) const {
    OMAnimatedC::serializeRelations(aomsRelations);
}

void OMAnimatedclass_3::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case class_3::state_1:
        {
            state_1_serializeStates(aomsState);
            break;
        }
        case class_3::state_0:
        {
            state_0_serializeStates(aomsState);
            break;
        }
        case class_3::state_2:
        {
            state_2_serializeStates(aomsState);
            break;
        }
        case class_3::state_3:
        {
            state_3_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedclass_3::state_3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_3");
}

void OMAnimatedclass_3::state_2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_2");
    if(myReal->state_2_subState == class_3::state_4)
        {
            state_4_serializeStates(aomsState);
        }
}

void OMAnimatedclass_3::state_4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_2.state_4");
}

void OMAnimatedclass_3::state_1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_1");
    if(myReal->state_1_subState == class_3::state_5)
        {
            state_5_serializeStates(aomsState);
        }
}

void OMAnimatedclass_3::state_5_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_1.state_5");
}

void OMAnimatedclass_3::state_0_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_0");
}
//#]

IMPLEMENT_REACTIVE_META_S_P(class_3, Default, false, C, OMAnimatedC, OMAnimatedclass_3)

OMINIT_SUPERCLASS(C, OMAnimatedC)

OMREGISTER_REACTIVE_CLASS
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\class_3.cpp
*********************************************************************/
