/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 19, Dec 2012  
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "C.h"
//#[ ignore
#define Default_C_C_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class C
C::C(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(C, C(), 0, Default_C_C_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        {
            itsD.setShouldDelete(false);
        }
        itsD.setActiveContext(theActiveContext, false);
    }
    initRelations();
    initStatechart();
}

C::~C() {
    NOTIFY_DESTRUCTOR(~C, true);
}

D* C::getItsD() const {
    return (D*) &itsD;
}

bool C::startBehavior() {
    bool done = true;
    done &= itsD.startBehavior();
    done &= OMReactive::startBehavior();
    return done;
}

void C::initRelations() {
    itsD._setItsC(this);
}

void C::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void C::destroy() {
    itsD.destroy();
    OMReactive::destroy();
}

void C::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.state_0");
        rootState_subState = state_0;
        rootState_active = state_0;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus C::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case state_0:
        {
            if(IS_EVENT_TYPE_OF(E_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.state_0");
                    //#[ transition 1 
                    getItsD()->GEN(F);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.state_1");
                    rootState_subState = state_1;
                    rootState_active = state_1;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            break;
        }
        case state_1:
        {
            if(IS_EVENT_TYPE_OF(G_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    NOTIFY_STATE_EXITED("ROOT.state_1");
                    NOTIFY_STATE_ENTERED("ROOT.state_0");
                    rootState_subState = state_0;
                    rootState_active = state_0;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            break;
        }
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedC::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsD", true, true);
    aomsRelations->ADD_ITEM(&myReal->itsD);
}

void OMAnimatedC::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case C::state_0:
        {
            state_0_serializeStates(aomsState);
            break;
        }
        case C::state_1:
        {
            state_1_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedC::state_1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_1");
}

void OMAnimatedC::state_0_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_0");
}
//#]

IMPLEMENT_REACTIVE_META_P(C, Default, Default, false, OMAnimatedC)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/
